using System;
using Zcu.Mve.Core;
using Zcu.Mve.Numerics;

namespace Examples
{
	/// <summary>
	/// Sample Module. Module calculates sinus of given number.
	/// </summary>
  [ModuleInfo("Milan Frank", "Module calculates sinus of given number.", CategoryType.Filter, CategoryData.Number, IconName="Sinus.ico")]
  [PortInfo("in", "Independent variable")]
  [PortInfo("out", "Dependent variable")]
  public class Sinus : Zcu.Mve.Core.Module
	{
    Scalar y = new Scalar();

		/// <summary>
		/// Creates ports.
		/// </summary>
    public Sinus()
		{
      AddInPort("in", typeof(Scalar));
      AddOutPort("out", typeof(Scalar));
		}
	
    /// <summary>
    /// Calculates a sinus value and sends it to output port.
    /// </summary>
    public override void Execute()
    {
      Scalar x = (Scalar) GetInput("in");

      y.Value = Math.Sin(x.Value);

      SetOutput("out", y);
    }
  }
}
