using System;
using System.Collections.Generic;
using System.Text;
using Zcu.Mve.Core;
using Zcu.Mve.Visualization;
using Zcu.Mve.Numerics;

namespace Examples
{
    class TestSource: Module
    {

        public TestSource()
        {
            AddOutPort("UnstrGrid", typeof(UnstrGrid));
        }

        public override void Execute()
        {
            UnstrGrid output = new UnstrGrid();
            UniformDataArray points = new UniformDataArray(typeof(PointND), 8);
            points[0] = new PointND(0, 0, 0, 0);
            points[1] = new PointND(1, 0, 0, 0);
            points[2] = new PointND(0, 1, 0, 0);
            points[3] = new PointND(0, 0, 1, 1);
            points[4] = new PointND(0, 5, 5, 0);
            points[5] = new PointND(6, 5, 5, 0);
            points[6] = new PointND(5, 6, 5, 0);
            points[7] = new PointND(5, 5, 6, 0);
            UniformDataArray tetrahedra = new UniformDataArray(typeof(Tetrahedron), 2);
            tetrahedra[0] = new Tetrahedron(0, 1, 2, 3);
            tetrahedra[1] = new Tetrahedron(4, 5, 6, 7);
            output.Points = points;
            output.AddCells("tetrahedra", tetrahedra);
            SetOutput("UnstrGrid", output);
        }
    }
}
