using System;
using System.Text;
using Zcu.Mve.Core;
using Zcu.Mve.Numerics;
using System.ComponentModel;
using System.IO;
using System.Collections;

namespace Zcu.Mve.Strings
{
	class DirectoryLister:Module
	{
		private bool paramsChanged = true;

		string dirName = "";

		[Editor(typeof(System.Windows.Forms.Design.FolderNameEditor), typeof(System.Drawing.Design.UITypeEditor))]
		public string DirName
		{
			get { return dirName; }
			set { dirName = value;
			paramsChanged = true;
		}
		}

		bool reload = false;

		public bool Reload
		{
			get { return reload; }
			set { reload = value; }
		}

		string[] files;
		MveString result;

		public DirectoryLister()
		{
			AddInPort("File number", typeof(Integer));
			AddOutPort("File name", typeof(MveString));
		}

		public override void Execute()
		{
			if (reload || paramsChanged || (!IsAllDataSame()))
			{
				files = Directory.GetFiles(dirName);
				int number = ((Integer)GetInput("File number")).Value;
				if (number >= files.Length)
				{
					throw new MveException(this, "The directory contains less than " + number + "files.");
				}
				Array.Sort(files);
				result = new MveString(files[number]);
				SetOutput("File name", result);
				paramsChanged = false;

                this.WriteLog("Directory", DirName);
			}
			else
			{
				SetOutput("File name", result, true);
			}

		}
	}
}
