using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Globalization;
using Zcu.Mve.Numerics;

namespace Zcu.Mve.Testing
{
    /// <summary>
    /// Panel pro vykreslen vektoru pomoc VectorRendereru.
    /// </summary>
    public class PositionRendererPanel : System.Windows.Forms.Form
    {
        private System.ComponentModel.IContainer components = null;
        PositionRenderer module;

        /// <summary>
        /// Konstruktor - vytvo panel a inicializuje jej.
        /// </summary>
        /// <param name="module"></param>
        public PositionRendererPanel(PositionRenderer module)
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            this.module = module;
        } // VectorRendererPanel()

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            // 
            // PositionRendererPanel
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(292, 266);
            this.Name = "PositionRendererPanel";
            this.Text = "Position Renderer Window";
            this.Resize += new System.EventHandler(this.PositionRendererPanel_Resize);

        }
        #endregion

        /// <summary>
        /// Vykresl obrzek do okna rendereru.
        /// </summary>
        /// <param name="e">Udlost.</param>
        protected override void OnPaint(PaintEventArgs e)
        {
            int w = this.ClientSize.Width / 2;
            int h = this.ClientSize.Height / 2;
            int x = (int)(module.pos1.X * w + w);
            int y = (int)(h - module.pos1.Y * h);

            Graphics g = e.Graphics;

            g.DrawLine(Pens.Black, 0, h, 2 * w, h);
            g.DrawLine(Pens.Black, w, 0, w, 2 * h);

            g.DrawEllipse(Pens.Blue, x - 5, y - 5, 10, 10);

            x = (int)(module.pos2.X * w + w);
            y = (int)(h - module.pos2.Y * h);
            g.DrawEllipse(Pens.Red, x - 5, y - 5, 10, 10);

            base.OnPaint(e);
        } // OnPaint()

        private void PositionRendererPanel_Resize(object sender, System.EventArgs e)
        {
            Invalidate();
        }

    } // class VectorRendererPanel
} // namespace Zcu.Mve.Testing

