using System;
using Zcu.Mve.Core;
using Zcu.Mve.Visualization;
using Zcu.Mve.Numerics;
using System.Drawing;

namespace Zcu.Mve.Testing
{
    /// <summary>
    /// Test source. Generates a new 2D grid and adds color cells to it.
    /// </summary>
    [ModuleInfo("Milan Frank", "Test source", CategoryType.Source, CategoryData.Image)]
    [PortInfo("value", "data array")]
    public class TestSource : Zcu.Mve.Core.Module
    {
        internal RectilinearGrid2D val;

        Color c;

        /// <summary>
        /// Gets/sets the color.
        /// </summary>
        public Color C
        {
            get { return (c); }
            set { c = value; }
        }

        /// <summary>
        /// Constructor.
        /// </summary>
        public TestSource()
        {
            double[] height = new double[5] { 1, 2, 3, 4, 5 };
            double[] width = new double[4] { 1, 2, 3, 4 };

            val = new RectilinearGrid2D(height, width);
            width[1] = 10;

            UniformDataArray2D colors = new UniformDataArray2D(typeof(ColorRGBA), height.Length - 1, width.Length - 1);
            colors[0, 1] = new ColorRGBA(0.2f, 0.2f, 0.4f);
            val.AddCellAttrs("color", colors);

            AddOutPort("value", val.GetType());
        }

        /// <inheritdoc />
        public override void Execute()
        {
            SetOutput("value", val);
        }
    }
}
