﻿using System;
using System.Collections.Generic;
using System.Text;
using Zcu.Mve.Core;
using Zcu.Mve.Visualization;

namespace Zcu.Mve.Visualization.Processing
{
    class AppendAttribute:Module
    {
        public AppendAttribute()
        {
            AddInPort("Unstrgrid", typeof(UnstrGrid));
            AddOutPort("Result", typeof(UnstrGrid));
            AddInPort("Attribute", typeof(UniformDataArray));
        }

        string attributeName = "attribute";

        public string AttributeName
        {
            get { return attributeName; }
            set { attributeName = value; }
        }

        bool cellAttribute = false;

        public bool CellAttribute
        {
            get { return cellAttribute; }
            set { cellAttribute = value; }
        }

        string cellName = "triangles";

        public string CellName
        {
            get { return cellName; }
            set { cellName = value; }
        }

        UnstrGrid result = null;

        public override void Execute()
        {
            if (IsAllDataSame() && IsAllUserSettingsSame())
            {
                SetOutput("Result", result, true);
            }
            else
            {
                UnstrGrid input = (UnstrGrid)GetInput("Unstrgrid");
                result = input.ShallowCopy();

                UniformDataArray attribute = (UniformDataArray)GetInput("Attribute");
                if (cellAttribute)
                    result.AddCellAttrs(cellName, attributeName, attribute);
                else
                    result.AddPointAttrs(attributeName, attribute);
                SetOutput("Result", result);
            }

        }
    }
}
