using System;
using System.Collections.Generic;
using System.Text;

namespace Zcu.Mve.Visualization
{
    /// <summary>
    /// This class represents multi dimensional static array of one specific DataObject.
    /// </summary>
    public class UniformDataArrayND : MveArray
    {
        /// <summary>
        /// For XmlLoader use only. Use parametric constructor instead.
        /// </summary>
        public UniformDataArrayND()
        {
            UpdateModificationTime();
        }

        /// <summary>
        /// Creates empty ND array of given type.
        /// </summary>
        /// <param name="lengths">Number of lines</param>
        /// <param name="type">The only accepted type</param>
        public UniformDataArrayND(Type type, params int[] lengths)
            : base(type, lengths)
        {
            UpdateModificationTime();
        }
    }
}
